#include <iostream>
#include <cmath>
#include <iomanip>

using namespace std;

double dot(double* a, double* b, int n) {
  double d = 0;
  for (int i = 0; i < n; ++i) {
    d += a[i]*b[i];
  }
  return d;
}

int main() {
  double w[1000], b, x[1000];
  int n;

  cin >> n;
  for (int i = 0; i < n; ++i) {
    cin >> w[i];
  }

  cin >> b;

  // compute the length of w
  double len_w = sqrt(dot(w, w, n));

  // never print in scientific notation
  cout.setf(ios::fixed);
  // always print 6 decimal digits with doubles
  cout.precision(6);

  // if there is no line left, then the condition is false
  while (cin >> x[0]) {
    for (int i = 1; i < n; ++i) {
      cin >> x[i];
    }
    cout << (dot(x, w, n) + b)/len_w << endl;
  }
  return 0;
}
